#ifndef __ALGORITHMAN__BINARYTREE_H
    #define __ALGORITHMAN__BINARYTREE_H

    #include <iostream>
    #include <string>
    #include <vector>

    namespace AlgorithMan
    {

        template<class T> class BinaryTreeNode;
         
        template<class T> class BinaryTree
        {
            private:
                BinaryTreeNode<T>* root;
                
            public:
                typedef typename BinaryTreeNode<T>::iterator iterator;
                
                BinaryTree();
                BinaryTree(const BinaryTree<T>& tree); // copy constructor
                BinaryTree(BinaryTree<T>&& tree); // move constructor
                
                //BinaryTree(const std::vector<T>& elements);
                BinaryTree<T>& operator=(const BinaryTree<T>& tree);
                virtual ~BinaryTree();
                void clear();
                static iterator end();

                iterator find(T element) const;
                iterator insert(T element);
                //void erase(T element);
                //void erase(BinaryTreeNode<T>::iterator element);
                
                void output(std::ostream& os) const;
                int depth() const;
                int nodes() const;
                int leaves() const;
        };
        
        template<class T> class BinaryTreeNode
        {
            friend class BinaryTree<T>;
            protected:
                T content;
                BinaryTreeNode<T>* lsucc;
                BinaryTreeNode<T>* rsucc;

                BinaryTreeNode<T>* Clone() const;
                
            public:
                typedef BinaryTreeNode<T>* iterator;

                BinaryTreeNode(T content);
                virtual ~BinaryTreeNode();
                
                static iterator end();
                void output(std::ostream& os, int depth) const;
                 
                int depth() const;
                int leaves() const;
                int nodes() const;
        };

    }

    #include "binarytree.cpp"
    
#endif
